openshot::Brightness Class Reference

This class adjusts the brightness and contrast of an image, and can be animated with openshot::Keyframe curves over time. More...

`#include <Brightness.h>`

Inheritance diagram for openshot::Brightness:

## Public Member Functions

| Brightness ()
| Blank constructor, useful when using Json to load the effect properties. More...
| Brightness (Keyframe new_brightness, Keyframe new_contrast)
| Default constructor, which takes 2 curves. The curves adjust the brightness and. More...
std::shared_ptr< Frame > | GetFrame (std::shared_ptr< Frame > frame, int64_t frame_number)
| This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object. More...
std::string | Json () const override
| Get and Set JSON methods. More...
Json::Value | JsonValue () const override
| Generate Json::Value for this object. More...
std::string | PropertiesJSON (int64_t requested_frame) const override
void | SetJson (const std::string value)
| Load JSON string into this object. More...
void | SetJsonValue (const Json::Value root)
| Load Json::Value into this object. More...
Public Member Functions inherited from openshot::EffectBase
int | constrain (int color_value)
| Constrain a color value from 0 to 255. More...
void | DisplayInfo ()
| Display effect information in the standard output stream (stdout) More...
void | InitEffectInfo ()
Json::Value | JsonInfo () const
| Generate JSON object of meta data / info. More...
int | Order () const
| Get the order that this effect should be executed. More...
void | Order (int new_order)
| Set the order that this effect should be executed. More...
virtual | ~EffectBase ()=default
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip. More...
float | Duration () const
| Get the length of this clip (in seconds) More...
float | End () const
| Get end position (in seconds) of clip (trim end of video) More...
void | End (float value)
| Set end position (in seconds) of clip (trim end of video) More...
std::string | Id () const
| Get basic properties. More...
void | Id (std::string value)
| Set basic properties. More...
int | Layer () const
| Get layer of clip on timeline (lower number is covered by higher numbers) More...
void | Layer (int value)
| Set layer of clip on timeline (lower number is covered by higher numbers) More...
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
float | Position () const
| Get position on timeline (in seconds) More...
void | Position (float value)

> Set the Id of this clip object

More...

float | Start () const
| Get start position (in seconds) of clip (trim start of video) More...
void | Start (float value)
| Set start position (in seconds) of clip (trim start of video) More...
virtual | ~ClipBase ()=default

## Public Attributes

Keyframe | brightness
| Brightness keyframe. A constant value here will prevent animation. More...
Keyframe | contrast
| Contrast keyframe. More...
Public Attributes inherited from openshot::EffectBase
EffectInfoStruct | info
| Information about the current effect. More...

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (std::string name, int value, int selected_value) const
| Generate JSON choice for a property (dropdown properties) More...
Json::Value | add_property_json (std::string name, float value, std::string type, std::string memo, const Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame) const
| Generate JSON for a property. More...
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip) More...
std::string | id
| ID Property for all derived Clip and Effect classes. More...
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips. More...
float | position
| The position on the timeline where this clip should start playing. More...
std::string | previous_properties
| This string contains the previous JSON properties. More...
float | start
| The position in seconds to start playing (used to trim the beginning of a clip) More...

## Detailed Description

This class adjusts the brightness and contrast of an image, and can be animated with openshot::Keyframe curves over time.

Adjusting the brightness and contrast over time can create many different powerful effects.

Definition at line 60 of file Brightness.h.

## Constructor & Destructor Documentation

## Brightness() [1/2]

Brightness::Brightness | ( |  | ) |

Blank constructor, useful when using Json to load the effect properties.

Definition at line 36 of file Brightness.cpp.

## Brightness() [2/2]

Brightness::Brightness | ( | Keyframe | new_brightness,
|  | Keyframe | new_contrast
| ) |  |

Default constructor, which takes 2 curves. The curves adjust the brightness and.

Parameters

  new_brightness | The curve to adjust the brightness (from -1 to +1, 0 is default/"off")
  new_contrast | The curve to adjust the contrast (3 is typical, 20 is a lot, 100 is max. 0 is invalid)

Definition at line 42 of file Brightness.cpp.

## Member Function Documentation

## GetFrame()

std::shared_ptr< Frame > Brightness::GetFrame | ( | std::shared_ptr< Frame > | frame,
|  | int64_t | frame_number
| ) |  |

virtual

This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object.

The frame object is passed into this method, and a frame_number is passed in which tells the effect which settings to use from its keyframes (starting at 1).

Returns
  The modified openshot::Frame object

Parameters

  frame | The frame object that needs the effect applied to it
  frame_number | The frame number (starting at 1) of the effect on the timeline.

Implements openshot::EffectBase.

Definition at line 64 of file Brightness.cpp.

## Json()

std::string Brightness::Json | ( |  | ) | const

override virtual

Get and Set JSON methods.

Generate JSON string of this object

Implements openshot::EffectBase.

Definition at line 100 of file Brightness.cpp.

## JsonValue()

Json::Value Brightness::JsonValue | ( |  | ) | const

override virtual

Generate Json::Value for this object.

Implements openshot::EffectBase.

Definition at line 107 of file Brightness.cpp.

Referenced by Json().

## PropertiesJSON()

std::string Brightness::PropertiesJSON | ( | int64_t | requested_frame | ) | const

override virtual

Get all properties for a specific frame (perfect for a UI to display the current state of all properties at any time)

Implements openshot::ClipBase.

Definition at line 150 of file Brightness.cpp.

## SetJson()

void Brightness::SetJson | ( | const std::string | value | ) |

virtual

Load JSON string into this object.

Implements openshot::EffectBase.

Definition at line 120 of file Brightness.cpp.

## SetJsonValue()

void Brightness::SetJsonValue | ( | const Json::Value | root | ) |

virtual

Load Json::Value into this object.

Implements openshot::EffectBase.

Definition at line 137 of file Brightness.cpp.

Referenced by SetJson().

## Member Data Documentation

## brightness

Keyframe openshot::Brightness::brightness

Brightness keyframe. A constant value here will prevent animation.

Definition at line 67 of file Brightness.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## contrast

Keyframe openshot::Brightness::contrast

Contrast keyframe.

Definition at line 68 of file Brightness.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

The documentation for this class was generated from the following files:

- Brightness.h
- Brightness.cpp